#!/bin/bash

DATA_DIR=$PWD/graph_data_small
#DATA_DIR=$PWD/graph_data_large

SCRIPT_DIR=$PWD

mkdir -p $DATA_DIR/rdata
$SCRIPT_DIR/Rgraphs.pl -blastout $DATA_DIR/1.out -rdata  $DATA_DIR/rdata -edges  $DATA_DIR/edge.tab -fasta  $DATA_DIR/allsequences.fa -incfrac 1 -evalue-file $DATA_DIR/evalue.tab
FIRST=`ls $DATA_DIR/rdata/perid* 2>/dev/null | head -1`
if [ -z "$FIRST" ]; then
    echo "Graphs failed, there were no edges. Continuing without graphs."
    touch $DATA_DIR/graphs.failed
    touch  $DATA_DIR/1.out.completed
    exit 0 #Exit with no error
fi
FIRST=`head -1 $FIRST`
LAST=`ls $DATA_DIR/rdata/perid*| tail -1`
LAST=`head -1 $LAST`
MAXALIGN=`head -1 $DATA_DIR/rdata/maxyal`
Rscript $SCRIPT_DIR/quart-align.r legacy $DATA_DIR/rdata $DATA_DIR/alignment_length_sm.png $FIRST $LAST $MAXALIGN 29323 700 315
Rscript $SCRIPT_DIR/quart-align.r legacy $DATA_DIR/rdata $DATA_DIR/alignment_length.png $FIRST $LAST $MAXALIGN 29323
Rscript $SCRIPT_DIR/quart-perid.r legacy $DATA_DIR/rdata $DATA_DIR/percent_identity.png $FIRST $LAST 29323
Rscript $SCRIPT_DIR/quart-perid.r legacy $DATA_DIR/rdata $DATA_DIR/percent_identity_sm.png $FIRST $LAST 29323 700 315
Rscript $SCRIPT_DIR/hist-edges.r legacy $DATA_DIR/edge.tab $DATA_DIR/number_of_edges.png 29323
Rscript $SCRIPT_DIR/hist-edges.r legacy $DATA_DIR/edge.tab $DATA_DIR/number_of_edges_sm.png 29323 700 315
Rscript $SCRIPT_DIR/hist-length.r legacy $DATA_DIR/length_uniprot.tab $DATA_DIR/length_histogram_uniprot.png 29323 ""
Rscript $SCRIPT_DIR/hist-length.r legacy $DATA_DIR/length_uniprot.tab $DATA_DIR/length_histogram_uniprot_sm.png 29323 "" 700 315


